#include <iostream>

class base {
	public:
		virtual void calc(double a) { m_cache=2.0*a; }
		void calc(int b) { m_cache=b; }
		virtual double get() const {return m_cache;}
		double& get() {return m_cache;}
		virtual void clear() {m_cache=0;}
		double m_cache=-3.;
};

class sub1 : public base {
	public:
		double calc(float b) { 
			m_tmp = m_cache; 
			m_cache=b; 
			return m_tmp; 
		}

		double& get() {return m_tmp;}
		double get() const {return m_cache;}

	private:
		double m_tmp=-2.;
};

class sub2 : public sub1 {
	public:
		void calc(double a) {
			m_cache=3.0;
		}

		void calc(int l) { m_cache=l; }
		virtual double get() const {return m_cache;}
		void clear() { m_cache=0; }

	private:
		double m_cache=-1.;
};

void print(base& c) {
	std::cout << c.get() << std::endl;

	double& val = c.get();
	val = 5.0;
	std::cout << c.get() <<std::endl;

	const base& f = c;
	std::cout << f.get() <<std::endl;

	c.clear();
	std::cout << c.get() <<std::endl;
	std::cout << f.get() <<std::endl;

	std::cout << std::endl
		<< "-----------------" << std::endl
		<< std::endl;
}

template<typename T>
void simple_print(T& t) {
	std::cout << t.get() << std::endl;
	
	const T& f = t;
	std::cout << f.get() << std::endl;

	std::cout << std::endl
		<< "-----------------" << std::endl
		<< std::endl;
};

void test_base(base& b, float n) {
	std::cout << "base" << std::endl;
	b.calc(n);
	print(b);
	b.calc(int(n));
	print(b);
	b.calc(n);
}

void test_1(sub1& b, float n) {
	std::cout << "test1" << std::endl;
	b.calc(n);
	print(b);
	b.calc(int(n));
	print(b);
	b.calc(n);
}

void test_2(sub2& b, float n) {
	std::cout << "test2" << std::endl;
	b.calc(n);
	print(b);
	b.calc(int(n));
	print(b);
	b.calc(n);
}

int main() {
	base b;
	sub1 s1;
	sub2 s2;

	test_base(b,1);

	std::cout << "################################" << std::endl;

	test_base(s1,1);
	test_1(s1,10);

	std::cout << "################################" << std::endl;

	test_base(s2,1);
	test_1(s2,10);
	test_2(s2,100);

	std::cout << "################################" << std::endl;

	simple_print(b);
	simple_print(s1);
	simple_print(s2);
}
