#include <cassert>

class Matrix {
	public:
		typedef unsigned int size_type;

		double operator() (const size_type i, const size_type j);
		double operator() (const size_type i, const size_type j) const;
		Matrix operator+ (Matrix M) const;
		Matrix& operator= (const Matrix& M);

		//set (*this) = (*this) + scale*B
		void add(const double& scale, const Matrix& B);

		size_type cols() const;
		size_type rows() const;
	
		Matrix(size_type rows,size_type cols);
		~Matrix();
		Matrix(const Matrix& M);

		/*
		class Iterator { 
			private:
				double* m_element;
				size_type m_row;
				size_type m_col;
			public:
				Iterator();
				bool operator!=(const Iterator& x) const;
				bool operator==(const Iterator& x) const;
				Iterator operator++(); // prefix
				Iterator operator++(int); // postfix
				double& operator*() const;
				double* operator->() const;
				friend class SymmetricMatrix;
		};
		Iterator begin() const;
		Iterator end() const;
		*/

	private:
		size_type m_cols;
		size_type m_rows;
		double* m_data;
};

//--------------------------------------------------

void
Matrix::add(const double& scale, const Matrix& B) {
	Matrix& A = *this;

	//check dimensions:
	assert(A.rows() == B.rows());
	assert(A.cols() == B.cols());

	for (size_type i=0; i < A.rows(); ++i) {
		for(size_type j=0; j < A.cols(); ++j) {
			A(i,j) = A(i,j) + scale*B(i,j);
		}
	}
}

