#include <cassert>
class Matrix {
	public:
		typedef unsigned int size_type;

		double& operator() (const size_type i, const size_type j) { return m_data[i+j*m_cols]; };
		double operator() (const size_type i, const size_type j) const { return m_data[i+j*m_cols]; };

		Matrix operator+ (Matrix M) const;
		Matrix& operator= (const Matrix& M) {
			if (this == &M) return *this;
			
			delete [] m_data;

			this->m_cols = M.m_cols;
			this->m_rows = M.m_rows;

			m_data = new double [m_cols*m_rows];
			for (int i = 0; i < m_cols*m_rows; i++) {
				m_data[i] = M.m_data[i];
			}

			return *this;	
		}

		//set (*this) = (*this) + scale*B
		void add(const double& scale, const Matrix& B);

		size_type cols() const;
		size_type rows() const;
	
		Matrix(size_type rows,size_type cols) {
			m_data = new double[rows*cols];
			m_cols = cols;
			m_rows = rows;
		}
		~Matrix() {
			delete [] m_data;
			m_data = nullptr;
		}

		Matrix(const Matrix& M) {
			this->m_cols = M.m_cols;
			this->m_rows = M.m_rows;

			m_data = new double [m_cols*m_rows];
			for (int i = 0; i < m_cols*m_rows; i++) {
				m_data[i] = M.m_data[i];
			}
		} 
	private:
		size_type m_cols;
		size_type m_rows;
		double* m_data;
};

//--------------------------------------------------

void
Matrix::add(const double& scale, const Matrix& B) {
	Matrix& A = *this;

	//check dimensions:
	assert(A.rows() == B.rows());
	assert(A.cols() == B.cols());

	for (size_type i=0; i < A.rows(); ++i) {
		for(size_type j=0; j < A.cols(); ++j) {
			A(i,j) = A(i,j) + scale*B(i,j);
		}
	}
}

